# ExtraEnemyCustomization (Version 1.x.x)
```
DISCLAIMER: This MOD is meant to be used by Rundown Developer to make their own enemy in ease. It's NOT a client-end MOD.
```

# ***[Use this Reference Config to learn how to use this MOD](https://github.com/GTFO-Modding/ExtraEnemyCustomization/raw/master/wikifiles/EEC_1.0/ExtraEnemyCustomization.zip)***
Un-zip them to your `YourRundownFolder/Custom/ExtraEnemyCustomization` path

# 1.3.0 Patch Note
 + Added: `BoneCustom/Prefabs` - Attach Whatever prefab you want to Bone
 + Added: `MarkerCustom/MarkerText` - Show customizable texts for Marker with formatting
 + Added: `MarkerCustom/ShowDistance` - Show Distance Indicator for Marker
 + Added: `Bleed[AttackCustom/Projectile]/CanBeStacked` - Set Bleeding setting to be stacked infinitely without overwriting existing one
 + Added: `ProjectileDefinitions/StaminaDrain` - Drain Stamina when got hit by projectile
 + Added: `ProjectileDefinitions/SpeedChange` - Change Projectile speed over time
 + Added: `ProjectileDefinitions/HomingStrengthChange` - Change Projectile homing strength over time
 + Performance Improvement: Bleeding now works smoother
 + Performance Improvement: Few Networking stuff has improved to send packet to target only
 + Fixed Issue: Bleeding now can display blood effect even when players are downed

# 1.2.10 Patch Note
 + Fixed Issue: Scout Color won't work properly on ScannerCustom

# 1.2.9 Patch Note
 + Improved surge alarm / initial level startup lag spike even further
 + Experimental::Add `Performance.LazySpawnedEvent` to `Global.jsonc` which could control new spawned event behaviour for optimizing lag spikes

# 1.2.8 Patch Note
 + Fixed Issue: DeathAbility, Config Reload now works again
 + ShadowCustom with `FullyInvisible` now works properly
 + ScannerCustom now works properly
 + ScannerCustom Wakeup color now works as intended without flashing

# 1.2.7 Patch Note
 + Fixed issue: Alarm Spawned Enemies doesn't have proper ScannerCustom color

# 1.2.6 Patch Note
 + Improved Performance related to ScannerCustom
 + Fixed issue where ScannerCustom shows incorrect color for few frame when handling blood door enemies
 + Add field `UpdateInterval` and `OptimizeAfterAwake` to ScannerCustom

# 1.2.5 Patch Note
 + Fixed issue where BirthingCustom were broken
 + Fixed issue where ShadowCustom always makes eggsacks invisible

# 1.2.4 Patch Note
 + Improved Performance
 + Fixed Bug Related to Rand Util

# 1.2.3 Patch Note
 + Improved Performance
 + Fixed Issue where Reactor/Generator cluster/Light events could affect EMP'ed light

# 1.2.2 Patch Note
 + Fixed Potential Issue that Explosion Effect could gone forever

# 1.2.1 Patch Note
 + Fixed Performance Issue related to Level Start
 + Fixed Performance Issue related to Explosion Ability

# 1.2.0 Patch Note
 + Now support .jsonc file as config
 + Added `Ability/StaminaDrainAttackCustom`
 + Added `Property.jsonc` replacing `SpawnCost.json`
 + Added `Property/EventsCustom`

# 1.1.1 Patch Note
 + Added Basic API for Plugin Developers under `EECustom.API` namespace
 + Fixed Issue: ExplosionAttack (or even more) Applied to wrong target
 + Fixed Issue: AgentModeTarget with multiple flags now reads properly
 + Fixed Issue: Potential Fix for CustomProjectile NullRefs

# 1.1.0 Patch Note
 + ### **Added Cloaking Ability!** - As always, check reference config file: `EnemyAbility.json`
 + Fixed Issue: Reloading Config Duplicates Customization process
 + Fixed Issue: Potential Jittering bug by Clock.Time


# Supported Features
 + ## Model Customization
    - `ShadowCustom`: Shadow Varient Customization (For every enemy model)
    - `MaterialCustom`: Material Swapper for changing skin of emenies
    - `GlowCustom`: for edting color of enemy glowing in general, also provide feature to adding custom Pulse Effect
    - `LimbCustom`: Enemy Limb Health/Weak/ArmorSpot Customization
    - `MarkerCustom`: Bio-tracker Ping Icon/Behaviour Customization (with custom images / texts)
    - `ModelRefCustom`: ModelReference Custom for editing Bio-Tracker Ping position/Shooter Firing Position/Striker Tentacle Position
    - `ScannerCustom`: Bio-tracker screen customization per enemies (with real-time color changes)
    - `SilhouetteCustom`: Provides enemies silhouette to be able to see through the wall
    - `BoneCustom`: Powerful setting to change each enemy's bodypart scale/position/rotation or Add your own Prefab to it

 + ## Ability Customization
    - `FogSphereCustom`: Fog Sphere Ability's Fog Setting
    - `BirthingCustom`: Birthing Ability Customization
    - `HealthRegenCustom`: for Health Regen/Decay Enemy
    - `InfectionAttackCustom`: for Infectious Tentacle/Punch
    - `ExplosiveAttackCustom`: for Explosive Tentacle/Punch
    - `KnockbackAttackCustom`: for adding knockback for Tentacle/Punch
    - `BleedAttackCustom`: for adding bleeding effect for Tentacle/Punch
    - `DrainStaminaAttackCustom`: for draining victim's stamina
    - `DoorBreakerCustom`: DoorBreaker Ability Speed/Damage Customization
    - `ScoutScreamingCustom`: Change Scout Screaming GlowColor and FogColor along with Infectious FogSphere

 + ## EnemyAbility Customization
    - `BehaviourAbilityCustom`: Trigger Ability based on Cooldown, Distance, LOS, State
    - `DeathAbilityCustom`: Trigger Ability when enemies death triggered

    * ### Supported Abilities
       - `DoAnim`
       - `FogSphere`
       - `Explosion`
       - `SpawnEnemy`
       - `SpawnWave`
       - `EMP`
       - `Cloak`
       - `Chain`: Trigger multiple ability at once!

 + ## Striker Tentacle Customization
    - `StrikerTentacleCustom`
       - Striker Tentacle Model Type Customization
       - Striker Tentacle In/Out/Stay time Custom
    - `TentacleDefinitions`
       - Work in Progress

 + ## Shooter Firing Customization
    - `ShooterFireCustom`
       - Shooter Projectile Setting Custom
       - Distance based Projectile Setting Swapper
    - `ProjectileDefinitions`
       - Custom Shooter Projectile Editing
       - Explosive Projectile
       - Knockback Projectile
       - Bleeding Projectile
       - Infectious Projectile
       - StaminaDrain Projectile

 + ## Detection Customization
    - `FeelerCustom`: Scout Feeler Count/Color/Distance Customization
    - `ScoutAnimCustom`: Customizable Scout Feeler Animation

 + ## Scout Wave Customization
    - Different wave setting per Scout Variants
    - StopOnDead Setting for Scout alive orientated constant alarm
    - Random Picker for having different wave setting for single variant

 + ## Property Customization
    - `SpawnCostCustom`: You can edit Enemy's spawncost without editing population settings
    - `EventsCustom`: Trigger WardenObjectiveEvent!
       - OnSpawnedEvent
       - OnWakeupEvent
       - OnDeadEvent
       - Triggering OnBossDeathEvent!

 + ## Miscellaneous Things
    - LiveEdit: Edit your config without reboot the game
    - Healer Enemies support: Negative Damage will now heal players
    - Global Config: Flyer Stuck Check

 + ## Partial Data Integration
    - You can use GUID to any enemy persistentID field if you using PartialData!


# Credits
 - peelz: Setup for future MTFO update
 - mccad00: Enemy Marker icons
 - Kasuromi: Providing codes related to SpawnCost / Helping me lot with PR review
 - Dex: Providing codes related to SilhouetteCustom
 - dakkhuza: Helping with implementing EMP / Providing codes related to Explosion